__author__ = 'shillaker'

OR = 'OR'
AND = 'AND'
ASCENDING = 'asc'
DESCENDING = 'desc'


# Generic field-value subquery
class FieldValuesSubQuery():
    def __init__(self, field, value, external_bool, internal_bool):
        self.field = field
        self.value = value
        self.external_bool = external_bool
        self.internal_bool = internal_bool


# Range subquery
class FieldRangeSubQuery():
    def __init__(self, field, range_bounds, external_bool, exclusive):
        self.field = field
        self.range = range_bounds
        self.external_bool = external_bool
        self.exclusive = exclusive


# Select range sub query
class SelectRangeSubQuery(FieldRangeSubQuery):
    def __init__(self, field, range_bounds, external_bool, exclusive):
        FieldRangeSubQuery.__init__(self, field, range_bounds, external_bool, exclusive)


# Select sub query
class SelectSubQuery(FieldValuesSubQuery):
    def __init__(self, field, value, external_bool, internal_bool):
        FieldValuesSubQuery.__init__(self, field, value, external_bool, internal_bool)


# Filter range sub query
class FilterRangeSubQuery(FieldRangeSubQuery):
    def __init__(self, field, range_bounds, external_bool, exclusive):
        FieldRangeSubQuery.__init__(self, field, range_bounds, external_bool, exclusive)


# Filter sub query
class FilterSubQuery(FieldValuesSubQuery):
    def __init__(self, field, value, external_bool, internal_bool):
        FieldValuesSubQuery.__init__(self, field, value, external_bool, internal_bool)


# Facet range field
class FacetRange():
    def __init__(self, field, start, end, gap):
        self.field = field
        self.start = start
        self.end = end
        self.gap = gap
        self.hardend = None
        self.includes = list()
        self.others = list()


